unit ktSysColorDialog; { v1.1	05/16/1998}

interface

uses
	Windows, Messages, SysUtils, Classes,	Graphics,	Controls,	Forms, Dialogs,
	Consts;

type
	PColorArray	=	^TColorArray;
	TColorArray	=	array[0..High(Cardinal)	div	SizeOf(TColorref)	-	1] of	TColorref;

	TktSysColorDialog	=	class(TColorDialog)
	private
		{	Private-Deklarationen	}
	protected
		{	Protected-Deklarationen	}
		procedure	LoadSysColors;
		procedure	SaveSysColors;
	public
		{	Public-Deklarationen }
		constructor	Create(AOwner: TComponent);	override;
		destructor Destroy;	override;
		function Execute:	Boolean; override;
	published
		{	Published-Deklarationen	}
	end;

procedure	Register;

implementation

uses
	Registry;

procedure	Register;
begin
	RegisterComponents('Dialogs',	[TktSysColorDialog]);
end;

function HexToInt(s: string):	Longint;
begin
	Result :=	StrToInt('$' + s);
end;

constructor	TktSysColorDialog.Create(AOwner: TComponent);
begin
	inherited	Create(AOwner);
end;

destructor TktSysColorDialog.Destroy;
begin
	inherited	Destroy;
end;

procedure	TktSysColorDialog.LoadSysColors;
var
	numEntries,	DataSize,	i: Integer;
	Reg: TRegistry;
	ColorArray:	PColorArray;
begin
	CustomColors.Clear;
	Reg	:= TRegistry.Create;
	with Reg do
	try
		RootKey	:= HKEY_CURRENT_USER;
		if OpenKey('Control	Panel\Appearance', FALSE)	then
		begin
			DataSize :=	GetDataSize('CustomColors');
			if DataSize	>	0	then
			begin
				ColorArray :=	AllocMem(DataSize);
				try
					numEntries :=	DataSize div SizeOf(TColorref);
					ReadBinaryData('CustomColors', ColorArray^,	DataSize);
					for	i	:= 0 to	numEntries - 1 do
						CustomColors.Add(SColorPrefix	+	chr(65 + i)	+	'='	+
							IntToHex(ColorArray^[i], 6));
				finally
					FreeMem(ColorArray);
				end;
			end;
		end;
	finally
		CloseKey;
		Free;
	end;
end;

procedure	TktSysColorDialog.SaveSysColors;
var
	numEntries,	DataSize,	i: Integer;
	s: string;
	Reg: TRegistry;
	ColorArray:	PColorArray;
begin
	Reg	:= TRegistry.Create;
	with Reg do
	try
		RootKey	:= HKEY_CURRENT_USER;
		if OpenKey('Control	Panel\Appearance', TRUE) then
		begin
			DataSize :=	GetDataSize('CustomColors');
			if DataSize	>	0	then
			begin
				ColorArray :=	AllocMem(DataSize);
				try
					numEntries :=	DataSize div SizeOf(TColorref);
					for	i	:= 0 to	numEntries - 1 do
					begin
						s	:= CustomColors.Strings[i];
						s	:= Copy(s, Pos('=',	s) + 1,	Length(s));
						ColorArray^[i] :=	HexToInt(s);
					end;
					WriteBinaryData('CustomColors',	ColorArray^, DataSize);
				finally
					FreeMem(ColorArray);
				end;
			end;
		end;
	finally
		CloseKey;
		Free;
	end;
end;

function TktSysColorDialog.Execute;
begin
	LoadSysColors;
	Result :=	inherited	Execute;
	if Result	then SaveSysColors;
end;

end.
